Commit | Line | Data |
cf8a192d |
1 | #! /bin/sh |
9a5ea778 |
2 | # hints/os2.sh |
3 | # This file reflects the tireless work of |
4 | # Ilya Zakharevich <ilya@math.ohio-state.edu> |
5 | # |
6 | # Trimmed and comments added by |
1973dd96 |
7 | # Andy Dougherty <doughera@lafayette.edu> |
9a5ea778 |
8 | # Exactly what is required beyond a standard OS/2 installation? |
f3e7aa1b |
9 | # (see in README.os2) |
4633a7c4 |
10 | |
eacfb5f1 |
11 | # Note that symbol extraction code gives wrong answers (sometimes?) on |
12 | # gethostent and setsid. |
4633a7c4 |
13 | |
26a1e0bd |
14 | # Optimization (GNU make 3.74 cannot be loaded :-(): |
15 | emxload -m 30 sh.exe ls.exe tr.exe id.exe sed.exe # make.exe |
16 | emxload -m 30 grep.exe egrep.exe fgrep.exe cat.exe rm.exe mv.exe cp.exe |
17 | emxload -m 30 uniq.exe basename.exe sort.exe awk.exe echo.exe |
18 | |
487a7f01 |
19 | path_sep=\; |
20 | |
21 | if test -f $sh.exe; then sh=$sh.exe; fi |
22 | |
23 | startsh="#!$sh" |
4633a7c4 |
24 | cc='gcc' |
84902520 |
25 | |
491527d0 |
26 | # Make denser object files and DLL |
27 | case "X$optimize" in |
28 | X) |
29 | optimize="-O2 -fomit-frame-pointer -malign-loops=2 -malign-jumps=2 -malign-functions=2 -s" |
30 | ld_dll_optimize="-s" |
31 | ;; |
32 | esac |
33 | |
f3e7aa1b |
34 | # Get some standard things (indented to avoid putting in config.sh): |
35 | oifs="$IFS" |
36 | IFS=" ;" |
37 | set $MANPATH |
38 | tryman="$@" |
39 | set $LIBRARY_PATH |
40 | libemx="$@" |
41 | set $C_INCLUDE_PATH |
42 | usrinc="$@" |
43 | IFS="$oifs" |
9b8c873d |
44 | tryman="`./UU/loc . /man $tryman`" |
f3e7aa1b |
45 | tryman="`echo $tryman | tr '\\\' '/'`" |
46 | |
47 | # indented to avoid having it *two* times at start |
9b8c873d |
48 | libemx="`./UU/loc os2.a /emx/lib $libemx`" |
f3e7aa1b |
49 | |
9b8c873d |
50 | usrinc="`./UU/loc stdlib.h /emx/include $usrinc`" |
f3e7aa1b |
51 | usrinc="`dirname $usrinc | tr '\\\' '/'`" |
52 | libemx="`dirname $libemx | tr '\\\' '/'`" |
53 | |
54 | if test -d $tryman/man1; then |
55 | sysman="$tryman/man1" |
56 | else |
9b8c873d |
57 | sysman="`./UU/loc . /man/man1 c:/man/man1 c:/usr/man/man1 d:/man/man1 d:/usr/man/man1 e:/man/man1 e:/usr/man/man1 f:/man/man1 f:/usr/man/man1 g:/man/man1 g:/usr/man/man1 /usr/man/man1`" |
f3e7aa1b |
58 | fi |
59 | |
60 | emxpath="`dirname $libemx`" |
61 | if test ! -d "$emxpath"; then |
9b8c873d |
62 | emxpath="`./UU/loc . /emx c:/emx d:/emx e:/emx f:/emx g:/emx h:/emx /emx`" |
f3e7aa1b |
63 | fi |
64 | |
65 | if test ! -d "$libemx"; then |
66 | libemx="$emxpath/lib" |
67 | fi |
84902520 |
68 | if test ! -d "$libemx"; then |
69 | if test -d "$LIBRARY_PATH"; then |
f3e7aa1b |
70 | libemx="$LIBRARY_PATH" |
84902520 |
71 | else |
9b8c873d |
72 | libemx="`./UU/loc . X c:/emx/lib d:/emx/lib e:/emx/lib f:/emx/lib g:/emx/lib h:/emx/lib /emx/lib`" |
84902520 |
73 | fi |
74 | fi |
75 | |
f3e7aa1b |
76 | if test ! -d "$usrinc"; then |
77 | if test -d "$emxpath/include"; then |
78 | usrinc="$emxpath/include" |
84902520 |
79 | else |
f3e7aa1b |
80 | if test -d "$C_INCLUDE_PATH"; then |
81 | usrinc="$C_INCLUDE_PATH" |
82 | else |
9b8c873d |
83 | usrinc="`./UU/loc . X c:/emx/include d:/emx/include e:/emx/include f:/emx/include g:/emx/include h:/emx/include /emx/include`" |
f3e7aa1b |
84 | fi |
84902520 |
85 | fi |
86 | fi |
87 | |
9b8c873d |
88 | rsx="`./UU/loc rsx.exe undef $pth`" |
eacfb5f1 |
89 | |
68dc0745 |
90 | if test "$libemx" = "X"; then echo "Cannot find C library!" >&2; fi |
eacfb5f1 |
91 | |
9607fc9c |
92 | # Acute backslashitis: |
93 | libpth="`echo \"$LIBRARY_PATH\" | tr ';\\\' ' /'`" |
94 | libpth="$libpth $libemx/mt $libemx" |
26a1e0bd |
95 | |
23da6c43 |
96 | set `cmd /c emxrev -f emxlibcm` |
26a1e0bd |
97 | emxcrtrev=$5 |
ed344e4f |
98 | # indented to not put it into config.sh |
99 | _defemxcrtrev=-D_EMX_CRT_REV_=$emxcrtrev |
4633a7c4 |
100 | |
101 | so='dll' |
102 | |
103 | # Additional definitions: |
104 | |
4633a7c4 |
105 | firstmakefile='GNUmakefile' |
4633a7c4 |
106 | exe_ext='.exe' |
4633a7c4 |
107 | |
cf8a192d |
108 | # We provide it |
109 | i_dlfcn='define' |
110 | |
a64c954a |
111 | # The default one uses exponential notation between 0.0001 and 0.1 |
112 | d_Gconvert='gcvt_os2((x),(n),(b))' |
113 | |
aade5aff |
114 | cat > UU/uselongdouble.cbu <<'EOCBU' |
115 | # This script UU/uselongdouble.cbu will get 'called-back' by Configure |
116 | # after it has prompted the user for whether to use long doubles. |
117 | # If we will use them, let Configure choose us a Gconvert. |
118 | case "$uselongdouble:$d_longdbl:$d_sqrtl:$d_modfl" in |
119 | "$define:$define:$define:$define") d_Gconvert='' ;; |
120 | esac |
121 | EOCBU |
122 | |
37286744 |
123 | # -Zomf build has a problem with _exit() *flushing*, so the test |
124 | # gets confused: |
125 | fflushNULL="define" |
126 | |
cf8a192d |
127 | aout_d_shrplib='undef' |
31e507d9 |
128 | aout_useshrplib='false' |
cf8a192d |
129 | aout_obj_ext='.o' |
130 | aout_lib_ext='.a' |
131 | aout_ar='ar' |
132 | aout_plibext='.a' |
491527d0 |
133 | aout_lddlflags="-Zdll $ld_dll_optimize" |
017f25f1 |
134 | # Cannot have 32000K stack: get SYS0170 ?! |
26a1e0bd |
135 | if [ $emxcrtrev -ge 50 ]; then |
017f25f1 |
136 | aout_ldflags='-Zexe -Zsmall-conv -Zstack 16000' |
26a1e0bd |
137 | else |
017f25f1 |
138 | aout_ldflags='-Zexe -Zstack 16000' |
26a1e0bd |
139 | fi |
140 | |
141 | # To get into config.sh: |
142 | aout_ldflags="$aout_ldflags" |
143 | |
144 | aout_d_fork='define' |
ed344e4f |
145 | aout_ccflags="-DDOSISH -DPERL_IS_AOUT -DOS2=2 -DEMBED -I. $_defemxcrtrev" |
146 | aout_cppflags="-DDOSISH -DPERL_IS_AOUT -DOS2=2 -DEMBED -I. $_defemxcrtrev" |
cf8a192d |
147 | aout_use_clib='c' |
148 | aout_usedl='undef' |
149 | aout_archobjs="os2.o dl_os2.o" |
b732e2e2 |
150 | # Not listed in dynamic_ext, but needed for AOUT static_ext nevertheless |
151 | aout_extra_static_ext="OS2::DLL" |
cf8a192d |
152 | |
153 | # variable which have different values for aout compile |
31e507d9 |
154 | used_aout='d_shrplib useshrplib plibext lib_ext obj_ext ar plibext d_fork lddlflags ldflags ccflags use_clib usedl archobjs cppflags' |
cf8a192d |
155 | |
eacfb5f1 |
156 | if [ "$emxaout" != "" ]; then |
cf8a192d |
157 | d_shrplib="$aout_d_shrplib" |
31e507d9 |
158 | useshrplib="$aout_useshrplib" |
cf8a192d |
159 | obj_ext="$aout_obj_ext" |
160 | lib_ext="$aout_lib_ext" |
161 | ar="$aout_ar" |
162 | plibext="$aout_plibext" |
26a1e0bd |
163 | if [ $emxcrtrev -lt 50 ]; then |
164 | d_fork="$aout_d_fork" |
165 | fi |
cf8a192d |
166 | lddlflags="$aout_lddlflags" |
167 | ldflags="$aout_ldflags" |
168 | ccflags="$aout_ccflags" |
169 | cppflags="$aout_cppflags" |
170 | use_clib="$aout_use_clib" |
171 | usedl="$aout_usedl" |
eacfb5f1 |
172 | else |
173 | d_shrplib='define' |
31e507d9 |
174 | useshrplib='true' |
eacfb5f1 |
175 | obj_ext='.obj' |
176 | lib_ext='.lib' |
177 | ar='emxomfar' |
178 | plibext='.lib' |
26a1e0bd |
179 | if [ $emxcrtrev -ge 50 ]; then |
180 | d_fork='define' |
181 | else |
182 | d_fork='undef' |
183 | fi |
f07bc2fb |
184 | lddlflags="-Zdll -Zomf -Zmt -Zcrtdll -Zlinker /e:2" |
4bf4dbb3 |
185 | # Recursive regmatch may eat 2.5M of stack alone. |
515b656f |
186 | ldflags='-Zexe -Zomf -Zmt -Zcrtdll -Zstack 32000 -Zlinker /e:2' |
26a1e0bd |
187 | if [ $emxcrtrev -ge 50 ]; then |
ed344e4f |
188 | ccflags="-Zomf -Zmt -DDOSISH -DOS2=2 -DEMBED -I. $_defemxcrtrev" |
26a1e0bd |
189 | else |
ed344e4f |
190 | ccflags="-Zomf -Zmt -DDOSISH -DOS2=2 -DEMBED -I. -DEMX_BAD_SBRK $_defemxcrtrev" |
26a1e0bd |
191 | fi |
eacfb5f1 |
192 | use_clib='c_import' |
cf8a192d |
193 | usedl='define' |
eacfb5f1 |
194 | fi |
195 | |
9b8c873d |
196 | # indented to miss config.sh |
197 | _ar="$ar" |
198 | |
eacfb5f1 |
199 | # To get into config.sh (should start at the beginning of line) |
9a5ea778 |
200 | # or you can put it into config.over. |
eacfb5f1 |
201 | plibext="$plibext" |
31e507d9 |
202 | # plibext is not needed anymore. Just directly set $libperl. |
203 | libperl="libperl${plibext}" |
eacfb5f1 |
204 | |
205 | #libc="/emx/lib/st/c_import$lib_ext" |
26a1e0bd |
206 | libc="$libemx/mt/$use_clib$lib_ext" |
eacfb5f1 |
207 | |
208 | if test -r "$libemx/c_alias$lib_ext"; then |
209 | libnames="$libemx/c_alias$lib_ext" |
210 | fi |
4633a7c4 |
211 | # otherwise puts -lc ??? |
212 | |
9a5ea778 |
213 | # [Maybe we should just remove c from $libswanted ?] |
214 | |
44a8e56a |
215 | # Test would pick up wrong rand, so we hardwire the value for random() |
216 | libs='-lsocket -lm -lbsd' |
217 | randbits=31 |
cf8a192d |
218 | archobjs="os2$obj_ext dl_os2$obj_ext" |
4633a7c4 |
219 | |
487a7f01 |
220 | # Run files without extension with sh: |
eacfb5f1 |
221 | EXECSHELL=sh |
4633a7c4 |
222 | |
223 | cccdlflags='-Zdll' |
cf8a192d |
224 | dlsrc='dl_dlopen.xs' |
4633a7c4 |
225 | ld='gcc' |
eacfb5f1 |
226 | |
227 | #cppflags='-DDOSISH -DOS2=2 -DEMBED -I.' |
4633a7c4 |
228 | |
4633a7c4 |
229 | # for speedup: (some patches to ungetc are also needed): |
230 | # Note that without this guy tests 8 and 10 of io/tell.t fail, with it 11 fails |
231 | |
eacfb5f1 |
232 | stdstdunder=`echo "#include <stdio.h>" | cpp | egrep -c "char +\* +_ptr"` |
4633a7c4 |
233 | d_stdstdio='define' |
234 | d_stdiobase='define' |
235 | d_stdio_ptr_lval='define' |
236 | d_stdio_cnt_lval='define' |
4633a7c4 |
237 | |
eacfb5f1 |
238 | if test "$stdstdunder" = 0; then |
239 | stdio_ptr='((fp)->ptr)' |
240 | stdio_cnt='((fp)->rcount)' |
241 | stdio_base='((fp)->buffer)' |
242 | stdio_bufsiz='((fp)->rcount + (fp)->ptr - (fp)->buffer)' |
243 | ccflags="$ccflags -DMYTTYNAME" |
244 | myttyname='define' |
245 | else |
246 | stdio_ptr='((fp)->_ptr)' |
247 | stdio_cnt='((fp)->_rcount)' |
248 | stdio_base='((fp)->_buffer)' |
249 | stdio_bufsiz='((fp)->_rcount + (fp)->_ptr - (fp)->_buffer)' |
250 | fi |
251 | |
252 | # to put into config.sh |
253 | myttyname="$myttyname" |
254 | |
255 | # To have manpages installed |
256 | nroff='nroff.cmd' |
257 | # above will be overwritten otherwise, indented to avoid config.sh |
258 | _nroff='nroff.cmd' |
259 | |
31e507d9 |
260 | # should be handled automatically by Configure now. |
eacfb5f1 |
261 | ln='cp' |
262 | # Will be rewritten otherwise, indented to not put in config.sh |
263 | _ln='cp' |
264 | lns='cp' |
265 | |
266 | nm_opt='-p' |
267 | |
cf8a192d |
268 | ####### We define these functions ourselves |
4633a7c4 |
269 | |
e75931a7 |
270 | d_strtoll='define' |
271 | d_strtoull='define' |
cf8a192d |
272 | d_getprior='define' |
273 | d_setprior='define' |
274 | |
84902520 |
275 | # The next two are commented. pdksh handles #!, extproc gives no path part. |
4633a7c4 |
276 | # sharpbang='extproc ' |
277 | # shsharp='false' |
278 | |
279 | # Commented: |
280 | #startsh='extproc ksh\\n#! sh' |
760ac839 |
281 | |
d6a255e6 |
282 | # Find patch: |
283 | gnupatch='patch' |
284 | if (gnupatch -v || gnupatch --version) 2>&1 >/dev/null; then |
285 | gnupatch=gnupatch |
286 | else |
287 | if (gpatch -v || gpatch --version) 2>&1 >/dev/null; then |
288 | gnupatch=gpatch |
289 | else |
290 | # They may have a special PATH during configuring |
291 | if (patch -v || patch --version) 2>&1 >/dev/null; then |
292 | gnupatch="`./UU/loc patch.exe undef $pth`" |
293 | fi |
294 | fi |
295 | fi |
296 | |
a64c954a |
297 | for f in less.exe less.sh less.ksh less.cmd more.exe more.sh more.ksh more.cmd ; do |
298 | if test -z "$pager"; then |
299 | pager="`./UU/loc $f '' $pth`" |
300 | fi |
301 | done |
302 | if test -z "$pager"; then |
303 | pager='cmd /c more' |
304 | fi |
305 | |
d6a255e6 |
306 | # Apply patches if needed |
307 | case "$0$running_c_cmd" in |
308 | *[/\\]Configure|*[/\\]Configure.|Configure|Configure.) # Skip Configure.cmd |
ee45ea83 |
309 | if test "Xyes" = "X$configure_cmd_loop"; then |
310 | cat <<EOC >&2 |
311 | !!! |
312 | !!! PANIC: Loop of self-invocations detected, aborting! |
313 | !!! |
314 | EOC |
315 | exit 20 |
316 | fi |
317 | configure_cmd_loop=yes |
318 | export configure_cmd_loop |
319 | |
320 | configure_needs_patch='' |
321 | if test -s ./os2/diff.configure; then |
322 | if ! grep "^#OS2-PATCH-APPLIED" ./Configure > /dev/null; then |
323 | configure_needs_patch=yes |
324 | fi |
325 | fi |
326 | if test -n "$configure_needs_patch"; then |
d6a255e6 |
327 | # Not patched! |
ee45ea83 |
328 | # Restore the initial command line arguments |
d6a255e6 |
329 | if test -f ./Configure.cmd ; then |
ee45ea83 |
330 | cat <<EOC >&2 |
331 | !!! |
332 | !!! I see that what is running is ./Configure. |
333 | !!! ./Configure is not patched, but ./Configure.cmd exists. |
334 | !!! |
335 | !!! You are supposed to run Configure.cmd, not Configure |
336 | !!! after an automagic patching. |
337 | !!! |
338 | !!! If you insist on running Configure, you may |
339 | !!! patch it manually from ./os2/diff.configure. |
340 | !!! |
341 | !!! However, I went through incredible hoolahoops, and I expect I can |
342 | !!! auto-restart Configure.cmd myself. I will start it with arguments: |
343 | !!! |
344 | !!! Configure.cmd $args_exp |
345 | !!! |
346 | EOC |
347 | rp='Do you want to auto-restart Configure.cmd?' |
348 | dflt='y' |
349 | . UU/myread |
350 | case "$ans" in |
351 | [yY]) echo >&4 "Okay, continuing." ;; |
352 | *) echo >&4 "Okay, bye." |
353 | exit 2 |
354 | ;; |
355 | esac |
356 | eval "set X $args_exp"; |
357 | shift; |
358 | # Restore the output |
359 | exec Configure.cmd "$@" 1>&2 |
d6a255e6 |
360 | exit 2 |
361 | fi |
ee45ea83 |
362 | cat <<EOC >&2 |
363 | !!! |
364 | !!! You did not patch ./Configure! |
365 | !!! I can create Configure.cmd and patch it from ./os2/diff.configure with the command |
366 | !!! |
367 | !!! $gnupatch -b -p1 --output=Configure.cmd <./os2/diff.configure 2>&1 | tee 00_auto_patch |
368 | EOC |
369 | rp='Do you want to auto-patch Configure to Configure.cmd?' |
370 | dflt='y' |
371 | . UU/myread |
372 | case "$ans" in |
373 | [yY]) echo >&4 "Okay, continuing." ;; |
374 | *) echo >&4 "Okay, bye." |
375 | exit 2 |
376 | ;; |
377 | esac |
d6a255e6 |
378 | ($gnupatch -b -p1 --output=Configure.cmd <./os2/diff.configure 2>&1 | tee 00_auto_patch) >&2 |
ee45ea83 |
379 | cat <<EOC >&2 |
380 | !!! |
381 | !!! The report of patching is copied to 00_auto_patch. |
382 | !!! Now we need to restart Configure.cmd with all the options. |
383 | !!! |
384 | EOC |
d6a255e6 |
385 | echo "extproc sh" > Configure.ctm |
ee45ea83 |
386 | ( cat Configure.cmd >> Configure.ctm && mv -f Configure.ctm Configure.cmd ) || (echo "!!! Failure to add extproc-line to Configure.cmd." >&2 ; exit 21) |
387 | cat <<EOC >&2 |
388 | !!! I went through incredible hoolahoops, and I expect I can |
389 | !!! auto-restart Configure.cmd myself. I will start it with arguments: |
390 | !!! |
391 | !!! Configure.cmd $args_exp |
392 | !!! |
393 | EOC |
394 | rp='Do you want to auto-restart Configure.cmd?' |
395 | dflt='y' |
396 | . UU/myread |
397 | case "$ans" in |
398 | [yY]) echo >&4 "Okay, continuing." ;; |
399 | *) echo >&4 "Okay, bye." |
400 | exit 2 |
401 | ;; |
402 | esac |
403 | eval "set X $args_exp"; |
404 | shift; |
405 | exec Configure.cmd "$@" 1>&2 |
406 | exit 2 |
d6a255e6 |
407 | else |
ee45ea83 |
408 | if test -s ./os2/diff.configure; then |
409 | echo "!!! Apparently we are running a patched Configure." >&2 |
410 | else |
411 | echo "!!! Apparently there is no need to patch Configure." >&2 |
412 | fi |
d6a255e6 |
413 | fi |
414 | ;; |
415 | *) echo "!!! Apparently we are running a renamed Configure: '$0'." >&2 |
416 | esac |
417 | |
7162771d |
418 | # This script UU/usethreads.cbu will get 'called-back' by Configure |
419 | # after it has prompted the user for whether to use threads. |
420 | cat > UU/usethreads.cbu <<'EOCBU' |
421 | case "$usethreads" in |
422 | $define|true|[yY]*) |
423 | ccflags="-Zmt $ccflags" |
424 | cppflags="-Zmt $cppflags" # Do we really need to set this? |
425 | aout_ccflags="-DUSE_THREADS $aout_ccflags" |
426 | aout_cppflags="-DUSE_THREADS $aout_cppflags" |
427 | aout_lddlflags="-Zmt $aout_lddlflags" |
428 | aout_ldflags="-Zmt $aout_ldflags" |
429 | ;; |
430 | esac |
431 | EOCBU |
432 | |
8dec540c |
433 | if test -z "$cryptlib"; then |
434 | cryptlib=`UU/loc crypt$lib_ext "" $libpth` |
435 | if $test -n "$cryptlib"; then |
436 | cryptlib=-lcrypt |
437 | else |
438 | cryptlib=`UU/loc ufc$lib_ext "" $libpth` |
439 | if $test -n "$cryptlib"; then |
440 | cryptlib=-lufc |
441 | fi |
442 | fi |
443 | fi |
444 | if test -n "$cryptlib"; then |
445 | libs="$libs $cryptlib" |
446 | # d_crypt=define |
447 | fi |
448 | |
760ac839 |
449 | # Now install the external modules. We are in the ./hints directory. |
450 | |
9b8c873d |
451 | cd ./os2/OS2 |
760ac839 |
452 | |
453 | if ! test -d ../../ext/OS2 ; then |
454 | mkdir ../../ext/OS2 |
455 | fi |
456 | |
457 | cp -rfu * ../../ext/OS2/ |
458 | |
459 | # Install tests: |
460 | |
35bc1fdc |
461 | cp -uf ../*.t ../../t/lib |
760ac839 |
462 | for xxx in * ; do |
463 | if $test -d $xxx/t; then |
464 | cp -uf $xxx/t/*.t ../../t/lib |
465 | else |
466 | if $test -d $xxx; then |
467 | cd $xxx |
468 | for yyy in * ; do |
469 | if $test -d $yyy/t; then |
470 | cp -uf $yyy/t/*.t ../../t/lib |
471 | fi |
472 | done |
473 | cd .. |
474 | fi |
475 | fi |
476 | done |
477 | |
5cf1d1f1 |
478 | case "$ldlibpthname" in |
479 | '') ldlibpthname=none ;; |
480 | esac |
481 | |
760ac839 |
482 | # Now go back |
9b8c873d |
483 | cd ../.. |
30500b05 |
484 | cp os2/*.t t/lib |